/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.ergebnis.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.ergebnis.entity.Gewaehlt;
import de.ivu.elect.business.ergebnis.entity.GewaehltUK;

public abstract class AbstractGewaehltDAO extends de.ivu.elect.jee.entity.AbstractDAO<Gewaehlt,
        de.ivu.elect.business.ergebnis.entity.GewaehltPK
    , GewaehltUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractGewaehltDAO.class);

  public AbstractGewaehltDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.ergebnis.entity.GewaehltPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public Gewaehlt findByPrimaryKey(
        de.ivu.elect.business.ergebnis.entity.GewaehltPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected Gewaehlt findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(Gewaehlt.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: CountErgebnisNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT COUNT(o) FROM Gewaehlt o WHERE o.ergebnis=?1<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountErgebnis( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("GEWAEHLT.CountErgebnis")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByCountErgebnis - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gewaehlt, findByCountErgebnis - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountErgebnis(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Gewaehlt o WHERE o.ergebnis=?1<br>
      * SQL: <br>
      */
     public java.util.List<Gewaehlt> findByErgebnis( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("GEWAEHLT.Ergebnis")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByErgebnis - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Gewaehlt, findByErgebnis - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnis(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.ergebnis.entity.GewaehltUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.ergebnis.entity.GewaehltUK uk,
        de.ivu.elect.business.ergebnis.entity.GewaehltPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

    public de.ivu.elect.business.ergebnis.entity.Gewaehlt findByUK(de.ivu.elect.business.ergebnis.entity.GewaehltUK uk){
        throw new UnsupportedOperationException("Kein UK definiert");
    }


}